Subject: Re: bug#19752: 25.0.50; fonts in HTML

From: Stefan Kangas <[email-masked]>
Date: Sat, 02 Nov 2019 00:40:12 +0100

Lars Ingebrigtsen <[email-masked]> writes:

> Richard Stallman <[email-masked]> writes:
>
>> I received message in Rmail which had this:
>>
>>     <body bgcolor="#ebebeb" class="ready" margin="0" padding="0" style="background:#ebebeb; margin:0; padding:0;">
>>
>> and a lot of the text was unreadable on the tty.  This seems to happen
>> with a lot of messages (even some that are not spam).
>>
>> Setting shr-inhibit-decoration to t made it possible to read the text.
>
> Looking at this a bit more, I'm going to guess that the problem is that
> on consoles, Emacs doesn't have enough colours to display this stuff
> sensibly.
>
> What does (display-color-cells) return for you?

FWIW, I tried this on the Linux console and got 8.  I guess ideally
Richard would try if evaluating the following and see if it solves the
problem for him:

    (setq shr-use-colors nil)

> If this is the case, we could fix this issue with something like the
> patch below.
>
> diff --git a/lisp/net/shr.el b/lisp/net/shr.el
> index 0cd15dcfe0..d4c99219bc 100644
> --- a/lisp/net/shr.el
> +++ b/lisp/net/shr.el
> @@ -72,9 +72,9 @@ shr-discard-aria-hidden
>    :version "27.1"
>    :type 'boolean)
>  
> -(defcustom shr-use-colors t
> +(defcustom shr-use-colors (> (display-color-cells) 256)
>    "If non-nil, respect color specifications in the HTML."
> -  :version "26.1"
> +  :version "27.1"
>    :type 'boolean)
>  
>  (defcustom shr-table-horizontal-line nil

Best regards,
Stefan Kangas